if(isFile("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	
	RTB_registerPref("Hover Height", "Hover Jet Player", "$Pref::HoverJetHeight", "int 1 100", "Player_Hover_Jet", 20, false, false, "");
}
else
	$Pref::HoverJetHeight = 20;

datablock PlayerData(PlayerHoverJet : PlayerStandardArmor)
{
	minJetEnergy = 10;
	rechargeRate = 1;
	maxEnergy = 20;
	canJet = 1;

	uiName = "Hover-Jet Player";
};

function Player::FlightCheck(%this)
{
	cancel(%this.FlightCheckLoop);
	if(%this.getDatablock() != PlayerHoverJet.getID())
		return;
	%pos = %this.getTransform();
	%masks = ($TypeMasks::InteriorObjectType 
	| $TypeMasks::FXBrickObjectType 
	| $TypeMasks::StaticShapeObjectType 
	| $TypeMasks::TerrainObjectType 
	| $TypeMasks::WaterObjectType);
	%r = containerRayCast(vectoradd(%pos,"0 0 1"), vectorAdd(%pos, "0 0" SPC (-1 * $Pref::HoverJetHeight)), %masks, %this);
	if(isObject(getWord(%r, 0)))
		%this.setEnergyLevel(20);
	else
		%this.setEnergyLevel(6);
	%this.FlightCheckLoop = %this.schedule(250, FlightCheck);
}

function PlayerHoverJet::OnNewDatablock(%this, %obj)
{
	Parent::OnNewDatablock(%this, %obj);
	%obj.FlightCheck();
}